import glob
import numpy as np
from scipy.io.wavfile import read


# get a signal and segmentation 
def get1wav_targSegmentation_sig(recname):#, data_dir):
    baseFs = 4000
    fs, data = read(recname + '.wav')
    assert fs == baseFs
    data = data.astype(np.float32)
    sigLen = data.shape[0]
    originalAnnotations = np.genfromtxt(recname + '.tsv')
    targ = createAllTargetSignal(originalAnnotations, sigLen, fs)
    return data, targ



def viewSegmentationRec(recName, data_dir):
    sigSegment, targ = get1wav_targSegmentation_sig(recName, data_dir)
    x = np.arange(len(sigSegment))
    plt.plot(x,sigSegment/1000,'b',x,targ,'r');plt.show()


## aux functions

def createAllTargetSignal(annotSamples, sigLen, fs):
    annotSamples[:,:2] = fs* annotSamples[:,:2]
    target = np.zeros(sigLen, dtype=np.float32)
    for ann in annotSamples:
        if ann[2] > 1e-10: # == 0.0
            st, nd = ann[0:2].astype(int)
            target[st:nd] = ann[2]
            #pdb.set_trace()
    return target   
        



# datadir = '/home/rui/research/challenge2022/official/trainData_1.03/training_data/'

# recname = datadir + '2530_TV'

# originalAnnotations = np.genfromtxt(recname + '.tsv')

# # get original sound data
# fs, data = read(recname + '.wav')
# assert fs == 4000
# data = data.astype(np.float32)
# sigLen = data.shape[0]

    
