import os
import pdb
import  numpy as np
import scipy as sp, scipy.io, scipy.io.wavfile
import tensorflow as tf
import helper_code as hc

#baseDir = '/home/rui/ensino/adne2022/ecgSounds/challenge2022/training_data/'

def get_murmur_locations(patient_data):
    """ for each location labels are -  0:Present 1:unknown 2: Absent"""
    Label = 0# 
    mloc = None
    for l in patient_data.split('\n'):
        if l.startswith('#Murmur: Absent'):
            return 2, []
        elif  l.startswith('#Murmur: Unknown'):
            return 1, ['AV','PV','TV','MV']
        elif l.startswith('#Murmur locations:'):
            try:
                mloc = l.split(': ')[1]
            except:
                pass
            if not mloc == 'nan':
               mloc = mloc.split('+')
            return 0, mloc


###### VERIFICAR !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        
def getLabels(recname):
    baseDir = os.path.dirname(recname)
    recnameNoPath = recname.split('/')[-1]
    patient_name = recnameNoPath.split('_')[0]
    patient_path = os.path.join(baseDir, patient_name) 
    locname = recnameNoPath.split('_')[1].split('.')[0]
    data = hc.load_patient_data(patient_path + '.txt')
    ## murmurs
    label, mloc = get_murmur_locations(data)
    if locname in mloc and label < 0.5: # there is murmur in this location
        murmur =  np.array(0.0).astype(np.float32)
    elif locname in mloc and label < 1.5: # unknow murmur for this and all locs
        murmur =  np.array(1.0).astype(np.float32)
    else:
        murmur = np.array(2.0).astype(np.float32)
    ## outcome
    outcome = hc.get_outcome(data)
    if outcome == 'Normal':
        outcomeV = np.array(1.0).astype(np.float32)
    else:
        outcomeV = np.array(0.0).astype(np.float32)
    return murmur, outcomeV

# def read_wav_files_and_labels(wavrecname):
#     #wavrecname = item.decode()
#     frequency, recording = sp.io.wavfile.read(wavrecname)
#     assert frequency==4000
#     label = getLabel(wavrecname)
#     return recording.astype(np.float32), label

